------------------------- MODULE OnePlaceBufferSpec -------------------------
EXTENDS Naturals, Integers, TLC, Sequences, Bags, FiniteSets
CONSTANTS   Message
VARIABLE mess, messOut, read_state

Init == /\ mess = Message
        /\ messOut = <<>>
        /\ read_state = TRUE
        
input == /\ IF Len(mess)>0 /\  read_state THEN 
               /\ messOut' = Append(messOut, Head(mess))
               /\ read_state' = FALSE
            ELSE
                UNCHANGED <<messOut, read_state>>  
         /\ UNCHANGED <<mess>>             
 
output == /\ IF ~ read_state THEN
               /\ read_state' = TRUE 
               /\ mess' = Tail(mess)
              ELSE 
                  UNCHANGED <<mess, read_state>>
          /\ UNCHANGED <<messOut>>             
 

               
 Next == input \/ output 
 
 Spec ==  Init /\ [][Next]_<<mess,messOut,read_state>>
          (*     /\ SF_<<mess,messOut,read_state>>(input)
               /\ SF_<<mess,messOut,read_state>>(output)  *)
 
 Fin == <>[](messOut = Message)


=============================================================================
\* Modification History
\* Last modified Sun Feb 17 10:02:24 NZDT 2019 by dstr
\* Created Sun Feb 17 09:35:51 NZDT 2019 by dstr
