------------------------------ MODULE dataWire ------------------------------
(* 

*)

EXTENDS Naturals, Integers, TLC, Sequences, Bags, FiniteSets
CONSTANTS   NULL, Message  \* to be set in model  to a sequence

(* --fair algorithm trade
variables sendDataQueue  = <<>>, \* data channel <<data, bit>>
         receiveDataQueue = <<>>;
        
 
fair+ process dataChannel = 3
begin
  Dt1:
  while  TRUE  do 
   data: 
     await (Len(sendDataQueue) > 0) ;   
     receiveDataQueue := <<Head(sendDataQueue)>>;
     sendDataQueue := Tail(sendDataQueue); 
  end while;
end process;
fair+ process dropChannel = 4
begin
  Dp1:
  while  TRUE  do  
    drop:
       await (Len(sendDataQueue) > 0) ;   
       sendDataQueue := Tail(sendDataQueue);           
  end while;
end process;
end algorithm; *)


\* BEGIN TRANSLATION
VARIABLES sendDataQueue, receiveDataQueue, pc

vars == << sendDataQueue, receiveDataQueue, pc >>

ProcSet == {3} \cup {4}

Init == (* Global variables *)
        /\ sendDataQueue = <<>>
        /\ receiveDataQueue = <<>>
        /\ pc = [self \in ProcSet |-> CASE self = 3 -> "Dt1"
                                        [] self = 4 -> "Dp1"]

Dt1 == /\ pc[3] = "Dt1"
       /\ pc' = [pc EXCEPT ![3] = "data"]
       /\ UNCHANGED << sendDataQueue, receiveDataQueue >>

data == /\ pc[3] = "data"
        /\ (Len(sendDataQueue) > 0)
        /\ receiveDataQueue' = <<Head(sendDataQueue)>>
        /\ sendDataQueue' = Tail(sendDataQueue)
        /\ pc' = [pc EXCEPT ![3] = "Dt1"]

dataChannel == Dt1 \/ data

Dp1 == /\ pc[4] = "Dp1"
       /\ pc' = [pc EXCEPT ![4] = "drop"]
       /\ UNCHANGED << sendDataQueue, receiveDataQueue >>

drop == /\ pc[4] = "drop"
        /\ (Len(sendDataQueue) > 0)
        /\ sendDataQueue' = Tail(sendDataQueue)
        /\ pc' = [pc EXCEPT ![4] = "Dp1"]
        /\ UNCHANGED receiveDataQueue

dropChannel == Dp1 \/ drop

Next == dataChannel \/ dropChannel

Spec == /\ Init /\ [][Next]_vars
        /\ WF_vars(Next)
        /\ SF_vars(dataChannel)
        /\ SF_vars(dropChannel)

\* END TRANSLATION


=============================================================================
\* Modification History
\* Last modified Thu Feb 14 16:27:55 NZDT 2019 by dstr
\* Created Thu Feb 14 15:38:49 NZDT 2019 by dstr
